@echo off
setlocal enableextensions enabledelayedexpansion 	|| exit /b

(SET SageTVDir=C:\Program Files\SageTV) 		|| exit /b
(SET backupDir=%~dp0SageTV) 				|| exit /b

REM might not work with your locale :-(
FOR /F "TOKENS=1* DELIMS= " %%A IN ('DATE /T') DO SET CDATE=%%B
FOR /F "TOKENS=1,2 eol=/ DELIMS=/ " %%A IN ('DATE /T') DO SET mm=%%B
FOR /F "TOKENS=1,2 DELIMS=/ eol=/" %%A IN ("%CDATE%") DO SET dd=%%B
FOR /F "TOKENS=2,3 DELIMS=/ " %%A IN ("%CDATE%") DO SET yyyy=%%B
SET date_=%yyyy%-%mm%-%dd%
SET folderName=%date_%
if errorlevel 1 exit /b


ECHO Backing up SageTV Common directory
call :do_copy "%SageTVDir%\" "Common"	|| exit /b


ECHO Backing up SageTV directory
call :do_copy "%SageTVDir%\" "SageTV"	|| exit /b


REM ECHO Backing up Irremote.ini
REM COPY "C:\WINXP\Irremote.ini" "%backupDir%\%folderName%\Irremote%date_%.ini" || exit /b


ECHO Compress it
"C:\Program Files\WinRAR\Rar.exe" a -r -idp -ep1 -m5 "%backupDir%\%folderName%.rar" "%backupDir%\%folderName%\*" || exit /b


ECHO Delete Backed up Directory but KEEP compressed backup
rd /s /q "%backupDir%\%folderName%" || exit /b

REM damned rmdir does not set errorlevel on XP
REM therefore I'll do additional check for existance (potential race condition here)
if exist "%backupDir%\%folderName%" (echo Can't delete "%backupDir%\%folderName%" & exit /b 1)


ECHO Backup for %date_% complete
exit /b


rem -------------------------------------------------------------
rem %1 -- source directory
rem %2 -- source item (file/directory) 
rem -------------------------------------------------------------
:do_copy
robocopy "%~1%~2" "%backupDir%\%folderName%\%~2" /E /NP
if %errorlevel% GEQ 8 (exit /b) else (exit /b 0)
